package com.datacloudsec.utils;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.apache.commons.compress.archivers.ArchiveEntry;
import org.apache.commons.compress.archivers.zip.Zip64Mode;
import org.apache.commons.compress.archivers.zip.ZipArchiveEntry;
import org.apache.commons.compress.archivers.zip.ZipArchiveInputStream;
import org.apache.commons.compress.archivers.zip.ZipArchiveOutputStream;

public class ComonZipUtil {

   public static void zip(String dir, String zippath) throws Exception {
      List paths = getFiles(dir);
      compressFilesZip((String[])paths.toArray(new String[paths.size()]), zippath, dir);
   }

   public static List getFiles(String dir) throws Exception {
      ArrayList lstFiles = null;
      if(lstFiles == null) {
         lstFiles = new ArrayList();
      }

      File file = new File(dir);
      File[] files = file.listFiles();
      File[] var7 = files;
      int var6 = files.length;

      for(int var5 = 0; var5 < var6; ++var5) {
         File f = var7[var5];
         if(f.isDirectory()) {
            lstFiles.add(f.getAbsolutePath());
            lstFiles.addAll(getFiles(f.getAbsolutePath()));
         } else {
            String str = f.getAbsolutePath();
            lstFiles.add(str);
         }
      }

      return lstFiles;
   }

   public static String getFilePathName(String dir, String path) throws Exception {
      String p = path.replace(dir + File.separator, "");
      p = p.replace("\\", "/");
      return p;
   }

   public static void compressFilesZip(String[] files, String zipFilePath, String dir) throws Exception {
      if(files != null && files.length > 0) {
         ZipArchiveOutputStream zaos = null;

         try {
            File e = new File(zipFilePath);
            zaos = new ZipArchiveOutputStream(e);
            zaos.setUseZip64(Zip64Mode.AsNeeded);
            String[] var8 = files;
            int var7 = files.length;

            for(int var6 = 0; var6 < var7; ++var6) {
               String strfile = var8[var6];
               File file = new File(strfile);
               if(file != null) {
                  String name = getFilePathName(dir, strfile);
                  ZipArchiveEntry zipArchiveEntry = new ZipArchiveEntry(file, name);
                  zaos.putArchiveEntry(zipArchiveEntry);
                  if(!file.isDirectory()) {
                     BufferedInputStream is = null;

                     try {
                        is = new BufferedInputStream(new FileInputStream(file));
                        byte[] e1 = new byte[1024];
                        boolean len = true;

                        int var34;
                        while((var34 = is.read(e1)) != -1) {
                           zaos.write(e1, 0, var34);
                        }

                        zaos.closeArchiveEntry();
                     } catch (Exception var30) {
                        throw var30;
                     } finally {
                        if(is != null) {
                           is.close();
                        }

                     }
                  }
               }
            }

            zaos.finish();
         } catch (Exception var32) {
            throw var32;
         } finally {
            try {
               if(zaos != null) {
                  zaos.close();
               }
            } catch (IOException var29) {
               throw var29;
            }

         }
      }
   }

   public static void unzip(File zipFile, File saveFile) throws Exception {
      if(!saveFile.exists()) {
         saveFile.mkdirs();
      }

      if(zipFile.exists()) {
         FileInputStream is = null;
         ZipArchiveInputStream zais = null;

         try {
            is = new FileInputStream(zipFile);
            zais = new ZipArchiveInputStream(is);
            ArchiveEntry e = null;

            while((e = zais.getNextEntry()) != null) {
               BufferedOutputStream os = null;

               try {
                  File e1 = new File(saveFile, e.getName());
                  if(e.getName().endsWith("/")) {
                     e1.mkdirs();
                  } else {
                     os = new BufferedOutputStream(new FileOutputStream(e1));
                     byte[] buffer = new byte[1024];
                     boolean len = true;

                     int len1;
                     while((len1 = zais.read(buffer)) != -1) {
                        os.write(buffer, 0, len1);
                     }
                  }
               } catch (IOException var24) {
                  throw new IOException(var24);
               } finally {
                  if(os != null) {
                     os.flush();
                     os.close();
                  }

               }
            }
         } catch (Exception var26) {
            throw var26;
         } finally {
            try {
               if(zais != null) {
                  zais.close();
               }

               if(is != null) {
                  is.close();
               }
            } catch (IOException var23) {
               throw var23;
            }

         }
      }

   }

   public static void main(String[] args) throws Exception {
      zip((new File("c:/OpenDLP")).getAbsolutePath(), "d:/opendlp.zip");
   }
}
